#include <stdio.h>
#include <math.h>
#include <malloc.h>
#include <stdlib.h>
#include <conio.h>
#include <time.h>

#ifndef LOS_IBAA
#define LOS_IBAA

#define MAXNUMER 4294967296.0

#define PI 3.14159

/*
 * ^ means XOR, & means bitwise AND, a<<b means shift a by b.
 * barrel(a) shifts a 19 bits to the left, and bits wrap around
 * ind(x) is (x AND 255), or (x mod 256)
 */
typedef  unsigned int  u4;      /* unsigned four bytes, 32 bits */
typedef  unsigned char u1;      /* unsigned one  byte,  8  bits */
#define ALPHA      (8)
#define SIZE       (1<<ALPHA)
#define ind(mm,x)  (*(u4 *)((u1 *)(mm) + ((x) & (255<<2))))
#define rngstep(mix,a,b,mm,m,m2,r,x) \
{ \
  x = *m;  \
  a = (a^(mix)) + *(m2++); \
  *(m++) = y = ind(mm,x) + a + b; \
  *(r++) = b = ind(mm,y>>8) + x; \
}

u4 *m1,*r1,aa1,bb1,cc1;
int los_ind;
int FLAGA=0;
  
static void isaac(u4 *mm,u4 *rr,u4 *aa,u4 *bb,u4 *cc)
//u4 *mm;      /* Memory: array of SIZE ALPHA-bit terms */
//u4 *rr;      /* Results: the sequence, same size as m */
//u4 *aa;      /* Accumulator: a single value */
//u4 *bb;      /* the previous result */
//u4 *cc;      /* Counter: one ALPHA-bit value */
{
  register u4 a,b,x,y,*m,*m2,*r,*mend;
  m=mm; r=rr;
  a = *aa; b = *bb + (++*cc);
  for (m = mm, mend = m2 = m+128; m<mend; )
  {
    rngstep( a<<13, a, b, mm, m, m2, r, x);
    rngstep( a>>6 , a, b, mm, m, m2, r, x);
    rngstep( a<<2 , a, b, mm, m, m2, r, x);
    rngstep( a>>16, a, b, mm, m, m2, r, x);
  }
  for (m2 = mm; m2<mend; )
  {
    rngstep( a<<13, a, b, mm, m, m2, r, x);
    rngstep( a>>6 , a, b, mm, m, m2, r, x);
    rngstep( a<<2 , a, b, mm, m, m2, r, x);
    rngstep( a>>16, a, b, mm, m, m2, r, x);
  }
  *bb = b; *aa = a;
}

//----------------------------------------------------//

void zacznij_rand()
{
time_t czas;

czas=time(NULL);
m1=(u4 *)malloc(SIZE*sizeof(u4));
r1=(u4 *)malloc(SIZE*sizeof(u4));


for(int i=0;i<SIZE;i++)
{
m1[i]=i;
}
aa1=0;
bb1=0;
cc1=0;
los_ind=0;

//while(!kbhit())
for(int i=0;i<czas%2546;i++)
{
isaac(m1,r1,&aa1,&bb1,&cc1);
printf("%u        \r",r1[5]);
}

}

//---------------------------------------------------//

double los()
{
double y;

if(FLAGA==0)
{
zacznij_rand();
FLAGA=1;
}

if(los_ind==0)
{
 isaac(m1,r1,&aa1,&bb1,&cc1);
}
y=(double)(r1[los_ind])/MAXNUMER;
los_ind++;
if(los_ind==SIZE)
los_ind=0;
return y;
}

//---------------------------------------------//

double Gauss()
{
       double u1,u2;
       u1=los();
       u2=los();
       return sqrt(-2.0*log(u1))*cos(2.0*PI*u2);
}

//-------------------------------------------------//

int Poiss(double lambda)
{
double U,P,c;
int NN;

c=exp(-lambda);
U=los();
P=U;
NN=0;
while(P>=c)
{
U=los();
P=P*U;
NN++;
}


return NN;
}


#endif
